#define MAXOPS	128
char *ops[MAXOPS];
char *nops[MAXOPS];
/*			Copyright 1979 by Bill Webb.	 		*/
/*			Copyright 1977 by Bill Webb.	 		*/
#define	NO_OP		0
#define	ERR_OP		0
#define	ADD_OP		1
#define	SUB_OP		2
#define	MUL_OP		3
#define	DIV_OP		4
#define	EXP_OP		5
#define	AND_OP		6
#define	OR_OP		7

#define	REL_OPS		8		/* base of relational ops */
#define	EQ_OP		8
#define	NE_OP		9
#define	GT_OP		10
#define	GE_OP		11
#define	LT_OP		12
#define	LE_OP		13
#define	EQV_OP		14
#define	XOR_OP		15
#define	CAT_OP		16
#define	NOT_OP		17
#define	NEG_OP		18

#define	GOTO_OP		21
#define	CGOTO_OP	22
#define	AGOTO_OP	23
#define	PAUSE_OP	24
#define	SPAUSE_OP	25
#define	STOP_OP		26
#define	SSTOP_OP	27
#define	STORE_OP	28
#define	SBV_OP		29
#define	FN_OP		30
#define	SYM_OP		31
#define	COMMA_OP	32
#define	CVT_OP		33
#define	SBA_OP		34
#define	AIF_OP		35
#define	LIF_OP		36
#define	RET_OP		37		/* function return */
#define	END_OP		38
#define	ERX_OP		39

#define	IO_BINARY	0
#define	IO_RANDOM	1
#define	IO_FMT		2
#define	IO_OBJECT	4
#define	IO_FREE		6	/* free format */
#define	IO_STR	7


#define	READ_OP		40
#define	UNFRD_OP	40		/* (READ_OP) */
#define	RANRD_OP	41		/* (READ_OP+IO_RANDOM) */
#define	FMTRD_OP	42		/* (READ_OP+IO_FMT) */
#define	RFMTRD_OP	43		/* (READ_OP+IO_RANDOM+IO_FMT) */
#define	OBJRD_OP	44		/* (READ_OP+IO_OBJECT) */
#define	ROBJRD_OP	45		/* (READ_OP+IO_RANDOM+IO_OBJECT) */
#define	FREERD_OP	46
#define	STRRD_OP	47

#define	DO_OP		48
#define	BCK_OP		49
#define	REW_OP		50
#define	ENF_OP		51
#define	ASS_OP		52
#define	DOEND_OP	53
#define	LABEL_OP	54
#define	CALL_OP		55
#define	MAIN_OP		56	/* entry to main program */
#define	SUBR_OP		57	/* entry to subroutine */
#define	RIF_OP		58	/* reverse if operator */
#define	ENTRY_OP	59	/* procedure entry */
#define	VEC_OP		60	/* vector i/o argument */
#define	DATA_OP		61
#define	FORMAT_OP	62
#define	CLOSE_OP	63
#define	AGO_OP		64	/* assigned goto, no list */
#define	BIF_OP		65	/* block if */
#define	ELSE_OP		66
#define	ENDIF_OP	67	/* end if */

#define	TEQ_OP		68
#define	TNE_OP		69
#define	TGT_OP		70
#define	TGE_OP		71
#define	TLT_OP		72
#define	TLE_OP		73
#define	SF_OP		74	/* statement function */
#define	SFENTRY_OP	75	/* entry to sf */
#define	RC_OP		76	/* call return code test */
#define	CHK_OP		77	/* check subscript */
#define	SRET_OP		78	/* subroutine return */
#define	STR_OP		79	/* string operator */

#define	WRITE_OP	80
#define	UNFWT_OP	80		/* (WRITE_OP) */
#define	RANWT_OP	81		/* (WRITE_OP+IO_RANDOM) */
#define	FMTWT_OP	82		/* (WRITE_OP+IO_FMT) */
#define	RFMTWT_OP	83		/* (WRITE_OP+IO_RANDOM+IO_FMT) */
#define	OBJWT_OP	84		/* (WRITE_OP+IO_OBJECT) */
#define	ROBJWT_OP	85		/* (WRITE_OP+IO_RANDOM+IO_OBJECT) */
#define	FREEWT_OP	86
#define	STRWT_OP	87

#define	STO_OP		88	/* string store operator */
#define	REC_OP		89	/* rec= for i/o stmts */
#define	IOSTAT_OP	90	/* iostat= for i/o stmts */
#define	RECL_OP		91
#define	BLANK_OP	92
#define	ACCESS_OP	93
#define	FORM_OP		94
#define	FILE_OP		95
#define	OPEN_OP		96
#define	SUBSTR_OP	97	/* substring op */
#define	INQ_OP		98	/* inquire */
#define	INQF_OP		99	/* inquire by file */
#define	NUM_OP		100	/* number= */
#define	NAME_OP		101	/* name= */
#define	SEQ_OP		102	/* sequential */
#define	DIR_OP		103	/* direct= */
#define	NAMED_OP	104	/* named= */
#define	FMTED_OP	105	/* formatted= */
#define	NEXT_OP		106	/* nextrec= */
#define	EXIST_OP	107	/* exist= */
#define	UNFMTED_OP	108	/* unformatted= */
#define	OPND_OP		109	/* opened */
#define FMT_OP		110	/* fmt= */
#define	ENDIO_OP	111	/* endio */
#define	STOS_OP		112	/* stos */
#define	TR_OP		113	/* tr */
#define	TRV_OP		114
#define	TRX_OP		115

#define	MOV_OP	SYM_OP
