#include "fmt.h"
/*			Copyright 1977 by Bill Webb.	 		*/
#include "fmtcc.h"
#include "fmthold.h"
 
struct cc ccs[] IS
{
"go",    C_misc o 0,    "go",
"comm",  C_misc o 1,    "comment",
"clea",  C_misc o 2,    "clear macros",
"end",   C_misc o 3,    "end of run",
"drop",  C_misc o 4,    "drop character",
"box",   C_misc o 5,    "box",
"tran",  C_misc o 6,    "translate",
"unde",  C_misc o 7,	"underscore blanks",
 
"spac",  C_value o 0,   "spacing",
"word",  C_value o 1,   "word spacing",
"vers",  C_value o 2,   "version",
"para",  C_value o 3,   "paragraph indent",
"sent",  C_value o 4,   "sentence separation",
"sepa",  C_value o 5,   "separate paragraphs",
"dark",  C_value o 6,   "dark print count",
"line",  C_value o 7 a 1,  "lines/page",
"text",  C_double o 9 a 3, "text line, print position",
"star",  C_double o 9 a 3, "start text line, position",
"card",  C_double o 11,  "card columns",
"page",  C_triple o 13,  "page number, line, disp",
"colu",  C_value o 16 a 4, "columns",
 
"set",   C_macro o 0,    "set",
"defi",  C_macro o 1,   "define",
"def",   C_macro o 1,   "define",
"eras",  C_macro o 2,   "erase",
"load",  C_macro o 3,    "load",
"call",  C_macro o 4,    "call",
 
"supe",  C_sw o 0,      "super fmt",
"tn",    C_sw o 1,      "tn print train",
"pn",    C_sw o 2,      "pn print train",
"trai",  C_sw o 2,      "pn print train",
"key",   C_sw o 3,      "special keypunch",
"gene",  C_sw o 4,      "generate )l's",
"fill",  C_rv o 4,      "fill text lines",
"list",  C_sw o 5,      "list source lines",
"numb",  C_sw o 6,      "number output",
"cont",  C_sw o 7,      "control card list",
"save",  C_sw o 8,      "save macro definitions",
"cycl",  C_sw o 9,      "cycle page numbers",
"hyph",  C_sw o 10,     "hyphenation",
"righ",  C_sw o 11,     "right hand page",
"left",  C_rv o 11,     "left hand page",
"repe",  C_sw o 12,     "repeat title",
"stop",  C_rv o 12,     "stop title",
"just",  C_sw o 13,     "justify",
"cap",   C_sw o 14,     "capitalize automatically",
"capi",  C_sw o 14,     "capitalize automatically",
"over",  C_sw o 15,     "overprint",
"full",  C_sw o 16,     "full source listing",
"simp",  C_sw o 17,     "simple cc",
"erro",  C_sw o 18,     "errors in line",
"debu",  C_sw o 19,     "debug output",
"shor",  C_sw o 20,     "short printer",
"term",	C_sw  o 21,	"terminal",
"fron", C_sw  o 22,	"front page",
"bold", C_sw  o 23,	"bold print",
"case", C_sw  o 24,	"macro case distinction",
 
"figu",  C_hold o 0,    "figure",
"lfoo",  C_hold o 1,    "left footer",
"rfoo",  C_hold o 2,    "right footer",
"ltit",  C_hold o 3,    "left title",
"rtit",  C_hold o 4,    "right title",
"subt",  C_hold o 5,    "subtitle",
"titl",  C_hold o 7,    "title",
"foote", C_hold o 8,    "footer",
"foot",  C_hold o 6,    "footnote",
 
"tab",   C_vector o 0,  "tab stops",
"inde",  C_vector o 1,  "indents",
"betw",  C_vector o 2 a 5,  "between column gaps",
"coun",  C_vector o 3,  "counters",
"widt",  C_vector o 5 a 2,  "column widths",
 
0
};
 
char *cc_sws[] IS
{
&sw_super, &sw_tn,   &sw_pn,   &sw_keyp,
&sw_gene,  &sw_list, &sw_numb,
&sw_cont,  &sw_save, &sw_cycle, &sw_hyph,
&sw_rt,  &sw_rep,  &sw_just,
&sw_cap, &sw_over, &sw_full,
&sw_simp,
&sw_error,
&sw_debug,
&sw_short,
&sw_term,
&sw_front,
&sw_bold,
&sw_mcase,
0
};
 
char cc_dsws[] IS               /* initial defaults for switches */
{OFF, ON, OFF, OFF, 
OFF, OFF, OFF, 
ON, IGNORE, OFF, ON,
ON, ON, ON, 
ON, ON, OFF, OFF,
OFF,
OFF,				/* sw_debug */
OFF,				/* sw_short */
OFF,				/* sw_term */
OFF,				/* sw_front */
OFF,				/* sw_bold */
LAST
};
 
struct value cc_values[] IS
{
/*
def min max    variable 
 */
1,  1,   3,   &spacing,
1,  0,   5,   &word_space,
1,  0,   X,   &version,
5,  0,   20,  &p_ind,
1,  0,   10,  &sent_space,
2,  0,   10,  &p_sep,
1,  1,   3,   &dark,
60, 10,999,   &line_max,
64, 10,MAXBUFF-1,   &col_width,
5,   1, 10,   &text_line,
5,   1, 64,   &text_col,
1,   1, 128,  &card_min,
MAXBUFF-1,20,MAXBUFF-1, &card_max,
1,   0, X,   &page.p_page,
1,   1, 128,  &page.p_line,
0,   0, 128,  &page.p_disp,
1,   1, MAXCOL, &columns,
0,   0,  0,   0
};
 
struct vec cc_vecs[] IS
{
/*
def min  max  variable   count vector type 		*/
 
0,   1,  MAXBUFF-1,     tabs,    MAXTAB,   0, 
0,-128,  128,  indents,  MAXIND*2,   0, 
2,   0,   20,     gaps,  MAXCOL-1,   0, 
0,   0,    X, counters,         6,   0,
0,-128,  128,    boxes, MAXBOX*MAXBCOL, 0,
0,   0,  MAXBUFF-1,   widths,    MAXCOL,   0,
0,   0,    0,         0,         0,   0,
};
 
 
struct hold *holds[] IS
{ &figure, &l_footer, &r_footer, &l_title, &r_title, 
    &sub_title, &footnote}; 

char nntab[] IS
{
'*','*','*','*','*','*','*','*','*','*',   /* invalid */
'(',')','+','-','{','}','[',']','*','*',   /* !10...!19 */
'*','*','*','*','*','*','*','-','*','*',   /* !20...!29 */
'*','*','&','|','~','<','=','>','+','(',   /* !30...!39 */
')','"','\'','*','#','%','@','_',';',':',  /* !40...!49 */
'?','!','*','*','*','*'
};

int fmt_put();
int (*out_addr) () IS fmt_put;
