/
/ random access I/O
/
/ int *avars[NUNITS]; 	/* pointers to associated variables for each unit. */
/ int reclens[NUNITS];	/* logical record lengths for units */
/ int nextrec[NUNITS];	/* next record index ... for read ahead */
/
.globl avars,reclen,bytecnt
.globl utable
.globl buffer
.globl rec_
.globl reci_
.globl rerr,unit,setio,reclens,nrecs
.globl ranwt_,ranrd_
.globl riowu,rioru
.globl setexits
ranwt_:
	clr	rdflg
	jsr	pc,setexits
	clr	-(sp)
	jsr	pc,riowu	/start random write
	jsr	pc,1f		/and update avar
	jmp	*(r4)+
ranrd_:
	mov	pc,rdflg	/reading
	jsr	pc,setexits
	clr	-(sp)
	jsr	pc,rioru
	jsr	pc,1f
	tst	r3		/any remainder?
	bne	0f
	mov	*avars(r0),nextrec(r0)	/store as next record index
0:
	jmp	*(r4)+
/ entered at end of I/O operation to update associated variable
1:
	mov	unit,r0
	asl	r0
	clr	r2
	mov	bytecnt,r3	/number of bytes moved
	div	reclen,r2	/get # of records
	add	r2,*avars(r0)
	rts	pc
indir = 0
.globl _dfile
/	call dfile(unit,nrecs,nwds,avar)
/		   *2    *4   *6   *8.
_dfile:
	mov	*2(r5),r1	/get unit #
	jsr	r5,setio; 43	/random access, binary
	mov	*6(r5),r0	/get # of words
	mov	unit,r1
	asl	r1
	asl	r0		/get in bytes
	mov	r0,reclens(r1)	/save record lengths 
	mov	*4(r5),nrecs(r1)	/save number of records
	cmpb	(r5),$4		/avar given
	blt	1f
	mov	8.(r5),avars(r1)	/save it
	br	0f
1:
	mov	$junk,avars(r1)		/dummy avar
0:
	rts	pc		/all ok
rec_:
reci_:
	mov	(sp)+,r2	/current record #
	mov	unit,r0		/get unit #
	asl	r0
	mov	r2,*avars(r0)
	mov	buffer,r1	/point to buffer
	mov	(r1)+,fdes	/file des
	cmp	r2,nextrec(r0)	/next one there?
	bne	1f		/different, so do seek
	tst	rdflg		/reading?
	beq	1f		/no, must seek for write
	clr	nextrec(r0)	/in case we don't come back
	mov	reclens(r0),reclen
	br	3f
1:
	clr	(r1)+		/empty the buffer
	clr	(r1)+		/completely
	clr	nextrec(r0)	/clear next record ptr
	mov	reclens(r0),r0
	mov	r0,reclen	/actual record length
	bne	0f
	jsr	r5,rerr	; 117.	/no define file done
0:
	dec	r2		/0 base indexing
	mul	r2,r0		/get location in file
/ r0 = high order, r1 = low order of seek addr
	clr	-(sp)		/how = 0 (abs)
	mov	r1,-(sp)	/lo order pos
	mov	r0,-(sp)	/hi order pos
	mov	fdes,-(sp)	/file des
.globl	lseek
	jsr	pc,lseek	/do long seek
	add	$8.,sp		/pop stack
	cmp	$-1,r0
	beq	7f		/oops, can't seek
/	tst	r0		/short seek?
/	beq	1f		/yes
// long seek, get blocks 
/	div	$512.,r0	/get blocks and offset
/	mov	r0,0f
/	mov	fdes,r0
/	sys	indir; 2f
/	bcs	7f
/.data
/2:	sys	seek; 0: 0; 3	/abs block seek 
/.text
/	mov	fdes,r0
/	mov	r1,0f		/offset
/	beq	3f		/block offset already
/	sys	indir;2f
/	bcs	7f		/bad seek
/.data
/2:	sys	seek; 0: 0; 1	/relative seek
/.text
3:
	jmp	*(r4)+		/and continue
7:	jsr	r5,rerr	; 116.	/seek failed on rec=
	br	3b
1:	mov	r1,0f
	mov	fdes,r0
	sys	indir; 2f
.data
2:	sys	seek; 0: 0; 0	/abs byte seek
.text
	bcs	7b
	br	3b
.bss
.globl reclens
reclens:	.=.+40
nrecs:	.=.+40
avars:	.=.+40
nextrec:.=.+40		/next record to read/write
junk:	.=.+2
fdes:	.=.+2
rdflg:	.=.+2
