/
/	io interface with unix fc library
/
.globl rerr
.globl iostati_,iostatq_
.globl setexits
.globl tr_i,tr_f,tr_d,tr_q
.globl tr_l,tr_b
.globl lio1,lio2
.globl iio2,iio4,rio4,rio8
.globl trx_
.globl tr_c,tr_h
.globl cio8,cio16
trx_:	jmp	*(r4)+		/dummy routine
tr_b:	jmp	lio1
tr_l:	jmp	lio2
tr_i:	jmp	iio2
tr_q:	jmp	iio4
tr_f:	jmp	rio4
tr_d:	jmp	rio8
tr_c:	jmp	cio8
tr_h:	jmp	cio16
.globl trx_s,sio
trx_s:
	jmp	sio
.globl fmtwt_,fmtrd_
.globl objwt_,objrd_
.globl endio,endio_
.globl iowf,iorf
.globl enf_,enfl
enf_:
	jsr	pc,setexits
	clr	-(sp)		/unit #
	jmp	enfl
objwt_:
fmtwt_:
	mov	(r4)+,r1	/format
	jsr	pc,setexits
	clr	-(sp)
	mov	r1,-(sp)
	jmp	iowf
objrd_:
fmtrd_:
	mov	(r4)+,r1	/format
	jsr	pc,setexits
	clr	-(sp)
	mov	r1,-(sp)	/format
	jmp	iorf
.globl unfwt_,unfrd_,iowu,ioru
unfwt_:
	jsr	pc,setexits
	clr	-(sp)
	jmp	iowu
unfrd_:
	jsr	pc,setexits
	clr	-(sp)
	jmp	ioru
endio_:
	jmp	endio
/
/ setexits expects two words on top of the stack, namely
/ 0(sp)		return address
/ 2(sp)		logical unit
/
setexits:
	setd			/set proper modes
	seti
	clr	endexit		/reset end=
	clr	errexit		/reset err=
	clr	iostati
	clr	iostatq
	mov	sp,r0
	cmp	(r0)+,(r0)+	/pop off the junk
	mov	r0,savesp	/and save it
/
	cmp	$err_,(r4)	/err = specified?
	bne	1f		/nope
	tst	(r4)+
	mov	(r4)+,errexit
1:
	cmp	$end_,(r4)	/end = specified?
	bne	1f		/nope
	tst	(r4)+
	mov	(r4)+,endexit
1:
	cmp	$iostati_,(r4)
	bne	1f
	tst	(r4)+
	mov	(r4)+,r0
	mov	r0,iostati
	clr	(r0)+
1:
	cmp	$iostatq_,(r4)
	bne	1f
	tst	(r4)+
	mov	(r4)+,r0
	mov	r0,iostatq
	clr	(r0)+
	clr	(r0)+
1:
	rts	pc		/and return
.globl ioerr,ioeof
/
/	error intercepts for io:
/	jsr	r5,ioerr
/	error #
/
ioerr:
	mov	(r5),r1		/get value
	jsr	pc,setstat
	tst	errexit
	bne	1f		/yes
	jmp	rerr		/no
1:
	mov	errexit,r4
2:
	mov	savesp,sp
	clr	errexit
	clr	endexit
	jmp	*(r4)+		/transfer to it
ioeof:
	mov	(r5),r1
	neg	r1		/for end= exit
	jsr	pc,setstat	/set iostat= value
	tst	endexit		/end= specified?
	bne	1f		/yes
	jmp	rerr		/no
1:
	mov	endexit,r4
	br	2b		/transfer control
/ set the status value
setstat:
	mov	iostati,r0
	beq	0f
	mov	r1,(r0)
0:	mov	iostatq,r0
	beq	0f
	tst	r1
	sxt	(r0)+
	mov	r1,(r0)
0:
	rts	pc
.globl iostati_,iostatq_
iostati_:
	mov	(r4)+,iostati
	jmp	*(r4)+
iostatq_:
	mov	(r4)+,iostatq
	jmp	*(r4)+
.globl end_,err_
end_:
	mov	(r4)+,endexit
	jmp	*(r4)+
err_:
	mov	(r4)+,errexit
	jmp	*(r4)+
.bss
.globl endexit,errexit,savesp
endexit:	.=.+2
errexit:	.=.+2
iostati:	.=.+2
iostatq:	.=.+2
savesp:	.=.+2
