.globl freewt_
.globl binflg,nspace,itmflg,scale,gflg,rdflg,cleario
.globl itype,ilen,width,col,ndig
.globl setio,fputc,fflush,locv,gocv,iocv,aocv
.globl setexits,getitm,eorec
.globl freewt,freerd
freewt_:
	jsr	pc,setexits
freewt:
	clr	rdflg
	mov	(sp)+,r1	/log unit
	jsr	r5,setio; 2	/write
	jsr	r5,cleario
/ start line with a blank
	movb	$' ,r0
	jsr	r5,fputc
1:
	clr	gflg
	jsr	r5,getitm	/get an item
		br	2f	/no item
	cmpb	$'r,itype	/real?
	bne	0f
	mov	$29.,width
	mov	$16.,ndig
	cmp	$8.,ilen
	beq	3f
	mov	$17.,width
	mov	$7.,ndig
3:
	jsr	r5,5f		/test if overflow
	jsr	r5,gocv
	br	1b
/
2:
	jsr	r5,eorec	/clean up
	jmp	*(r4)+
0:
	cmpb	$'i,itype	/integer?
	bne	0f
	mov	$13.,width
	cmp	$4,ilen		/long?
	beq	3f
	mov	$7.,width	/7 wide
3:
	clr	ndig
	jsr	r5,5f		/test if overflow
	jsr	r5,iocv		/output it
	br	1b
0:
	cmpb	$'s,itype	/string?
	bne	0f
	mov	ilen,width
	jsr	r5,5f		/test if overflow
	jsr	r5,aocv
	br	1b
0:
	cmpb	$'l,itype	/logical?
	bne	0f
	mov	$9.,width
	jsr	r5,5f		/test if overflow
	jsr	r5,locv
	br	1b
/ test if this will overflow line, if so then flush it
5:
	mov	col,r0
	add	width,r0
	cmp	r0,$72.
	blt	0f
	jsr	r5,eorec
	mov	$' ,r0
	jsr	r5,fputc
0:
	rts	r5
.globl freerd_,ioerr,fgetc,nlflg,eorec,ficv,licv,fungetc,ilval,bflg,eoftst
freerd_:
	jsr	pc,setexits
freerd:
	mov	pc,rdflg
	mov	(sp)+,r1	/log unit
	jsr	r5,setio; 1	/read
	jsr	r5,cleario
	mov	$-1,bflg	/stop on blanks
	jsr	r5,eoftst	/test for eof
5:
	jsr	r5,getitm	/get variable
		br	2f	/done
	mov	$80.,width
	clr	ndig
1:	jsr	r5,scan		/scan for non-blank
	cmpb	$',,r0		/comma
	beq	5b		/yes, leave unchanged
	tst	r0
	bpl	0f		/not end of line
	jsr	r5,eorec	/get new record
	jsr	r5,eoftst	/test for eof
	clr	nlflg
	br	1b
/ end of read item list
2:
	jsr	r5,eorec	/end of input
	jmp	*(r4)+
/ non-blank character found
0:	jsr	r5,fungetc	/put it back
/ got something, so go to proper routine
	cmpb	$'s,itype	/string?
	beq	1f
	cmpb	$'l,itype	/logical?
	beq	2f
	jsr	r5,ficv		/convert and store it
	br	comma		/and continue
2:	jsr	r5,licv
	br	comma
/ character string
/ if first character is a quote then accept it as a delimiter
/ otherwise use blank and comma
1:
	mov	ilen,r2
	mov	ilval,r1	/get pointer
	jsr	r5,fgetc	/get it again
	mov	$" ,,delims	/use blank or comma
	cmpb	$'',r0		/start with quote?
	beq	0f
	cmpb	$'",r0		/start with quote?
/ allow string terminated by blank or comma
	bne	1f		/already got a charcter
0:	mov	r0,delims	/use quote as delim
/ loop reading characters
0:	jsr	r5,fgetc	/get character
/ got a charcter, test if its a delimiter
1:	cmpb	delims,r0		/end of string?
	beq	1f
	cmpb	delims+1,r0		/end of string?
	beq	1f
	tst	nlflg		/ not delim, so test if end of line
	beq	2f
	jsr	r5,eorec	/get new record
	jsr	r5,eoftst	/test for eof
	br	0b
/ store into character variable, if not already full
2:	tst	r2
	ble	0b
	movb	r0,(r1)+
	dec	r2
	br	0b
/ got delim, test if followed by a quote
1:	tstb	delims+1	/quote delimeter?
	bne	1f		/nope
	jsr	r5,fgetc	/get another one
	cmpb	delims,r0	/test if same quote
	beq	2b	/put it in the line
/ found end of string 
1:	tst	r2
	ble	comma
2:	movb	$' ,(r1)+
	sob	r2,2b		/loop, filling with blanks
	br	comma
/ scan for non-blank character, return -1 if end of line
scan:
0:
	jsr	r5,fgetc
	cmpb	$' ,r0		/blank?
	bne	1f		/nope
	tst	nlflg
	beq	0b		/nope
	mov	$-1,r0		/mark end of line
1:	rts	r5		/and return
/ scan for trailing comma
comma:
	tst	nlflg
	bne	1f		/end of line
	jsr	r5,fungetc	/throw back last character
	jsr	r5,fgetc	/test for comma
	cmpb	$',,r0		/test for comma
	beq	1f
	jsr	r5,scan		/scan for non-blank
	cmpb	$',,r0		/is it comma?
	beq	1f
	jsr	r5,fungetc
1:
	br	5b		/and continue
.bss
delims:	.=.+2			/free format delimeters
